/*
 * Copyright 2013 Mark Slater
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.
 */

package net.sourceforge.urin;

abstract class PercentEncodingUnaryValue<ENCODING> extends UnaryValue<ENCODING> {

    private final PercentEncodingPartial.PercentEncoding<ENCODING> percentEncoding;

    PercentEncodingUnaryValue(final ENCODING value, final PercentEncodingPartial.PercentEncoding<ENCODING> percentEncoding) {
        super(value);
        this.percentEncoding = percentEncoding;
    }

    final String asString() {
        return percentEncoding.encode(value);
    }

}
